package com.fr.plugin.decision.core;

import com.fr.plugin.decision.core.action.AddAction;
import com.fr.plugin.decision.core.action.CoverAction;
import com.fr.plugin.decision.core.action.CreateAction;
import com.fr.plugin.decision.core.action.ExcelDmlAction;

import java.util.HashMap;
import java.util.Map;

public class ActionFactory {

    private static Map actionMap = new HashMap();
    private static ActionFactory actionFactory = new ActionFactory();

    private ActionFactory(){
    }

    public static ActionFactory getInstance(){
        return actionFactory;
    }

    public ExcelDmlAction create(String type){
        return (ExcelDmlAction) actionMap.get(ActionEunm.fromTypeName(type));
    }

    {
        actionMap.put(ActionEunm.ADDTO_ACTION, new AddAction());
        actionMap.put(ActionEunm.COVER_ACTION, new CoverAction());
        actionMap.put(ActionEunm.CREATE_ACTION,new CreateAction());
    }
}
