package com.fr.plugin.decision.core;

import com.fr.base.TemplateUtils;
import com.fr.data.core.db.DBUtils;
import com.fr.data.core.db.dialect.Dialect;
import com.fr.data.core.db.dml.AbstractDML;
import com.fr.data.core.db.dml.Table;
import com.fr.log.FineLoggerFactory;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;

public class Drop extends AbstractDML {
    protected Drop(Table table, Dialect dialect) {
        super(table, dialect);
    }

    @Override
    protected PreparedStatement createPreparedStatementByValidatedParameters(Connection connection) throws SQLException {
        String dropSQL = TemplateUtils.render("DROP TABLE ${table} ", new String[]{"table"}, new String[]{this.getTable().toStatementSQLString(this.dialect)});
        FineLoggerFactory.getLogger().debug(dropSQL.toString());
        PreparedStatement preparedStatement = connection.prepareStatement(dropSQL);

        return preparedStatement;
    }

    // todo: executeUpdate 执行 drop 后的返回值
    public int execute(Connection connection) throws SQLException {
        PreparedStatement preparedStatement = this.createPreparedStatement(connection);

        int result;
        try {
            if (preparedStatement == null) {
                return 0;
            }

            result = preparedStatement.executeUpdate();
        } finally {
            DBUtils.closeStatement(preparedStatement);
        }

        return result;
    }
}
