package com.fr.plugin.decision.core;

import com.fr.data.core.db.dml.Table;
import com.fr.json.JSONArray;
import com.fr.json.JSONObject;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

public class ExcelDmlBean {

    private String connectionName;
    private Table table;
    private int rowCount;
    private Map<String, List> tableValue;
    private List<String> tableColName = new ArrayList<>();
    private List<String> tableColLength = new ArrayList<>();
    private List<Integer> tableColType = new ArrayList<>();
    private List<Boolean> tablePrimaryKey = new ArrayList<>();

    public ExcelDmlBean(String connectionName, String schema, String tableName, JSONArray tableColItems, Map<String, List> tableValue){
        this.connectionName = connectionName;
        this.tableValue = tableValue;
        for (Object o : tableColItems) {
            String colName = ((JSONObject) o).getString("colName");
            String colLength = ((JSONObject) o).getString("colLength");
            int colType = ((JSONObject) o).getInt("colType");
            boolean primaryKey = ((JSONObject) o).getBoolean("primaryKey");
            tableColName.add(colName);
            tableColType.add(colType);
            tableColLength.add(colLength);
            tablePrimaryKey.add(primaryKey);
        }

        table = new Table(schema, tableName);
        rowCount = tableValue.get(tableColName.get(0)).size();
    }

    public List<Boolean> getTablePrimaryKey() {
        return tablePrimaryKey;
    }

    public void setTablePrimaryKey(List<Boolean> tablePrimaryKey) {
        this.tablePrimaryKey = tablePrimaryKey;
    }

    public Table getTable() {
        return table;
    }

    public int getRowCount() {
        return rowCount;
    }

    public List<String> getTableColLength() {
        return tableColLength;
    }

    public String getConnectionName() {
        return connectionName;
    }

    public void setConnectionName(String connectionName) {
        this.connectionName = connectionName;
    }

    public Map<String, List> getTableValue() {
        return tableValue;
    }

    public void setTableValue(Map<String, List> tableValue) {
        this.tableValue = tableValue;
    }

    public List<String> getTableColName() {
        return tableColName;
    }

    public void setTableColName(List<String> tableColName) {
        this.tableColName = tableColName;
    }

    public List<Integer> getTableColType() {
        return tableColType;
    }

    public void setTableColType(List<Integer> tableColType) {
        this.tableColType = tableColType;
    }
}
