package com.fr.plugin.decision.core.action;

import com.fr.data.core.db.DBUtils;
import com.fr.json.JSONObject;
import com.fr.log.FineLoggerFactory;
import com.fr.plugin.decision.core.DML;

import java.sql.PreparedStatement;

public class AddAction extends ExcelDmlAction {

    public AddAction() {
    }

    @Override
    public JSONObject execute() {
        PreparedStatement preparedStatement = null;
        JSONObject result = JSONObject.create();
        int count = -1;
        try {
            conn.setAutoCommit(false);
            preparedStatement = DML.createInsertedPreparedStatement(
                    dialect,
                    conn,
                    excelDmlBean.getTable(),
                    excelDmlBean.getTableColName()
            );

            count = DML.execInsertedPreparedStatement(
                    dialect,
                    conn,
                    excelDmlBean.getTable(),
                    preparedStatement,
                    excelDmlBean.getRowCount(),
                    excelDmlBean.getTableColName(),
                    excelDmlBean.getTableColType(),
                    excelDmlBean.getTableValue()
            );

            conn.commit();
            conn.setAutoCommit(true);
            result.put("status", "success").put("text", "成功追加数据条数为 "+ count +"条").put("addLink",false);

        } catch (Exception e) {
            FineLoggerFactory.getLogger().error("HW_excel导入:AddAction failed !", e.getMessage());
            DBUtils.rollback(conn);
            e.printStackTrace();
            result.put("status", "fail").put("errorText", "追加操作数据插入异常" + e.getLocalizedMessage());
        } finally {
            DBUtils.close(conn);
            DBUtils.close(preparedStatement);
        }

        return result;
    }
}
