package com.fr.plugin.decision.core.action;

import com.fr.data.core.db.DBUtils;
import com.fr.json.JSONObject;
import com.fr.log.FineLoggerFactory;
import com.fr.plugin.decision.core.DML;

import java.sql.PreparedStatement;

public class CoverAction extends ExcelDmlAction {

    public CoverAction() {
    }

    @Override
    public JSONObject execute() {
        PreparedStatement preparedStatement = null;
        JSONObject result = JSONObject.create();
        int insertCount = 0;
        int deleteCount = 0;
        try {
            conn.setAutoCommit(false);
            deleteCount = DML.deleteTable(
                    dialect,
                    conn,
                    excelDmlBean.getTable()
            );

            preparedStatement = DML.createInsertedPreparedStatement(
                    dialect,
                    conn,
                    excelDmlBean.getTable(),
                    excelDmlBean.getTableColName()
            );

            insertCount = DML.execInsertedPreparedStatement(
                    dialect,
                    conn,
                    excelDmlBean.getTable(),
                    preparedStatement,
                    excelDmlBean.getRowCount(),
                    excelDmlBean.getTableColName(),
                    excelDmlBean.getTableColType(),
                    excelDmlBean.getTableValue()
            );
            conn.commit();
            conn.setAutoCommit(true);
            result.put("status", "success").put("text", "成功删除数据" + deleteCount + "条，插入数据 " + insertCount +"条").put("addLink",false);
        } catch (Exception e) {
            FineLoggerFactory.getLogger().error("HW_excel导入:CoverAction failed !", e.getMessage());
            DBUtils.rollback(conn);
            e.printStackTrace();
            result.put("status", "fail").put("errorText", "覆盖操作数据插入异常" + e.getLocalizedMessage());
        } finally {
            DBUtils.close(conn);
            DBUtils.close(preparedStatement);
        }
        return result;
    }
}
