package com.fr.plugin.decision.core.action;

import com.fr.data.core.db.DBUtils;
import com.fr.json.JSONObject;
import com.fr.log.FineLoggerFactory;
import com.fr.plugin.decision.core.DML;

import java.sql.PreparedStatement;
import java.sql.SQLException;

public class CreateAction extends ExcelDmlAction {
    public CreateAction() {
    }

    @Override
    public JSONObject execute() {
        PreparedStatement preparedStatement = null;
        JSONObject result = JSONObject.create();
        int count = 0;
        try {
            conn.setAutoCommit(false);
            DML.createTable(
                    dialect,
                    conn,
                    excelDmlBean.getTable(),
                    excelDmlBean.getTableColName(),
                    excelDmlBean.getTableColLength(),
                    excelDmlBean.getTableColType(),
                    excelDmlBean.getTablePrimaryKey()
            );
            preparedStatement = DML.createInsertedPreparedStatement(
                    dialect,
                    conn,
                    excelDmlBean.getTable(),
                    excelDmlBean.getTableColName()
            );
            count = DML.execInsertedPreparedStatement(
                    dialect,
                    conn,
                    excelDmlBean.getTable(),
                    preparedStatement,
                    excelDmlBean.getRowCount(),
                    excelDmlBean.getTableColName(),
                    excelDmlBean.getTableColType(),
                    excelDmlBean.getTableValue()
            );
            conn.commit();
            conn.setAutoCommit(true);
            result.put("status", "success").put("text", "表创建正常，成功插入数据" + count + "条").put("addLink",true);
        } catch (Exception e) {
            FineLoggerFactory.getLogger().error("HW_excel导入:CreateAction failed !", e.getMessage());
            DBUtils.rollback(conn);
            try {
                DML.dropTable(dialect, conn, excelDmlBean.getTable());
            } catch (SQLException e1) {
                FineLoggerFactory.getLogger().error("HW_excel导入:dropTable failed !", e.getMessage());
            }
            e.printStackTrace();
            result.put("status", "failed").put("errorText", "新增操作异常" + e.getLocalizedMessage());
        } finally {
            DBUtils.close(conn);
            DBUtils.close(preparedStatement);
        }

        return result;
    }
}
