package com.fr.plugin.decision.dialect;

import com.fr.log.FineLoggerFactory;
import com.fr.plugin.decision.dialect.gauss.GaussDialectConsummate;
import com.fr.plugin.decision.dialect.hive.HiveDialectConsummate;
import com.fr.plugin.decision.dialect.postgre.PostgreDialectConsummate;
import com.fr.plugin.decision.dialect.sybase.SybaseDialectConsummate;
import com.fr.stable.StringUtils;
import com.fr.stable.UrlDriver;
import com.fr.stable.fun.impl.AbstractDialectCreator;

import java.sql.Connection;
import java.sql.SQLException;

public class DialectCreator extends AbstractDialectCreator {
    @Override
    public Class<?> generate(UrlDriver urlDriver) {
        return null;
    }

    @Override
    public Class<?> generate(Connection connection) {
        try {
            String DatabaseProductName = connection.getMetaData().getDatabaseProductName().trim().toUpperCase();
            FineLoggerFactory.getLogger().debug("DialectCreator:" + DatabaseProductName);
            if (StringUtils.contains(DatabaseProductName,"POSTGRE")){
                return PostgreDialectConsummate.class;
            } else if (StringUtils.contains(DatabaseProductName,"SYBASE")){
                return SybaseDialectConsummate.class;
            } else if (StringUtils.contains(DatabaseProductName,"ZENITH")){ // gauss
                return GaussDialectConsummate.class;
            } else if (StringUtils.contains(DatabaseProductName,"HIVE")){
                return HiveDialectConsummate.class;
            }

        } catch (SQLException e) {
            e.printStackTrace();
        }
        return null;
    }
}
