package com.fr.plugin.decision.dialect.gauss;

import com.fr.data.core.db.dialect.Dialect;
import com.fr.data.core.db.dialect.base.key.column.typetosql.AbstractDialectColumnType2SQLExecutor;
import com.fr.data.core.db.dialect.base.key.column.typetosql.DialectColumnType2SQLParameter;
import com.fr.data.core.db.dialect.util.DialectUtils;

public class GaussDialectColumnType2SQLExecutor extends AbstractDialectColumnType2SQLExecutor {
    public GaussDialectColumnType2SQLExecutor(){

    }

    @Override
    public String execute(DialectColumnType2SQLParameter dialectColumnType2SQLParameter, Dialect dialect) {
        int columnType = dialectColumnType2SQLParameter.getColumnType();
        String columnSize = dialectColumnType2SQLParameter.getParameter();
        switch(columnType) {
            case -7:
                return "bit";
            case -5:
                return "numeric(" + columnSize + ")";
            case -4:
                return "image";
            case -3:
                return "varbinary(" + columnSize + ")";
            case -2:
                return "binary(" + columnSize + ")";
            case -1:
                return "text";
            case 1:
                return "char(" + columnSize + ")";
            case 2:
                return "numeric(" + columnSize + ")";
            case 3:
                return "decimal(" + columnSize + ")";
            case 4:
                return "int";
            case 8:
                return "float";
            case 12:
                return "varchar(" + columnSize + ")";
            case 16:
                return "boolean";
            case 91:
                return "datetime";
            case 92:
                return "datetime";
            case 93:
                return "datetime";
            case 2004:
                return "image";
            case 2005:
                return "text";
            default:
                return DialectUtils.getTypeName(dialectColumnType2SQLParameter.getColumnType());
        }
    }
}
