package com.fr.plugin.decision.dialect.hive;

import com.fr.data.core.db.dialect.Dialect;
import com.fr.data.core.db.dialect.base.key.column.typetosql.AbstractDialectColumnType2SQLExecutor;
import com.fr.data.core.db.dialect.base.key.column.typetosql.DialectColumnType2SQLParameter;
import com.fr.data.core.db.dialect.util.DialectUtils;

public class HiveDialectColumnType2SQLExecutor extends AbstractDialectColumnType2SQLExecutor {
    public HiveDialectColumnType2SQLExecutor(){

    }

    @Override
    public String execute(DialectColumnType2SQLParameter dialectColumnType2SQLParameter, Dialect dialect) {
        int columnType = dialectColumnType2SQLParameter.getColumnType();
        String columnSize = dialectColumnType2SQLParameter.getParameter();
        switch(columnType) {
            case -7:
                return "boolean";
            case 1:
                return "char(" + columnSize + ")";
            case 2:
                return "bigint";
            case 3:
                return "decimal(" + columnSize + ")";
            case 4:
                return "int";
            case 7:
                return "float";
            case 8:
                return "float";
            case 12:
                return "varchar(" + columnSize + ")";
            case 16:
                return "boolean";
            case 91:
                return "date";
            case 92:
                return "date";
            case 93:
                return "date";
            case 2004:
                return "image";
            case 2005:
                return "text";
            default:
                return DialectUtils.getTypeName(columnType);
        }
    }
}
