package com.fr.plugin.decision.http;

import com.fr.data.core.db.DBUtils;
import com.fr.data.core.db.dialect.Dialect;
import com.fr.data.core.db.dialect.DialectFactory;
import com.fr.data.core.db.dml.Table;
import com.fr.decision.fun.impl.BaseHttpHandler;
import com.fr.json.JSONObject;
import com.fr.log.FineLoggerFactory;
import com.fr.plugin.decision.core.DML;
import com.fr.plugin.decision.dao.ExcelLinkService;
import com.fr.plugin.decision.dao.ExcelMngEntity;
import com.fr.plugin.decision.utils.JdbcUtils;
import com.fr.third.springframework.web.bind.annotation.RequestMethod;
import com.fr.web.utils.WebUtils;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.sql.Connection;
import java.sql.Statement;

public class
DeleteLinkHttpHandle extends BaseHttpHandler {
    @Override
    public RequestMethod getMethod() {
        return null;
    }

    @Override
    public String getPath() {
        return "/excelmng/delete";
    }

    @Override
    public boolean isPublic() {
        return false;
    }

    @Override
    public void handle(HttpServletRequest req, HttpServletResponse res) throws Exception {
        final String id = WebUtils.getHTTPRequestParameter(req,"id");

        ExcelMngEntity entity = ExcelLinkService.getInstance().getLinkById(id);
        if (entity == null){
            WebUtils.printAsJSON(res,new JSONObject().put("status","fail"));
            FineLoggerFactory.getLogger().error("HW_excel导入:链接根据Id查询结果为空");
            return;
        }

        String connection = entity.getDatasouces();
        String tableName  = entity.getTablename();
        String schema = entity.getSchema();
        Connection conn = null;

        try {
            conn = JdbcUtils.getConnection(connection);
            Dialect dialect = DialectFactory.generateDialect(conn);
            Table table = new Table(schema, tableName);
            DML.deleteTable(dialect, conn, table);

            FineLoggerFactory.getLogger().info("表删除成功");
            ExcelLinkService.getInstance().deleteLinkById(id);
            WebUtils.printAsJSON(res,new JSONObject().put("status","success"));

        } catch (Exception e) {
            e.printStackTrace();
            FineLoggerFactory.getLogger().info("表删除失败");
            WebUtils.printAsJSON(res, new JSONObject().put("status","fail"));
        } finally {
            DBUtils.close(conn);
        }
    }
}
