package com.fr.plugin.decision.http;

import com.fr.decision.fun.impl.BaseHttpHandler;
import com.fr.decision.webservice.bean.user.UserSearchBean;
import com.fr.decision.webservice.v10.user.UserService;
import com.fr.json.JSONObject;
import com.fr.plugin.decision.utils.HttpUtils;
import com.fr.third.springframework.web.bind.annotation.RequestMethod;
import com.fr.web.utils.WebUtils;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Map;

public class GetAllUserListHandler extends BaseHttpHandler {
    @Override
    public RequestMethod getMethod() {
        return null;
    }

    @Override
    public String getPath() {
        return "/excelmng/getAllUserList";
    }

    @Override
    public boolean isPublic() {
        return false;
    }

    @Override
    public void handle(HttpServletRequest req, HttpServletResponse res) throws Exception {
        try {
            String adminId = UserService.getInstance().getAdminUserNameList().get(0);
            UserSearchBean userSearchBean = HttpUtils.readObject(req, UserSearchBean.class);
            Map<String, Object> userList = UserService.getInstance().getAllUsers(adminId, userSearchBean,false);
            WebUtils.printAsJSON(res, new JSONObject().put("status", "success").put("data", userList));
        } catch (Exception e) {
            e.printStackTrace();
            WebUtils.printAsJSON(res, new JSONObject().put("status", "fail"));
        }
    }
}
