package com.fr.plugin.decision.http;

import com.fr.data.core.db.DBUtils;
import com.fr.data.core.db.dialect.Dialect;
import com.fr.data.core.db.dialect.DialectFactory;
import com.fr.decision.fun.impl.BaseHttpHandler;
import com.fr.json.JSONArray;
import com.fr.json.JSONObject;
import com.fr.plugin.decision.utils.JdbcUtils;
import com.fr.stable.StringUtils;
import com.fr.third.springframework.web.bind.annotation.RequestMethod;
import com.fr.web.utils.WebUtils;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;

public class GetSchemaHttpHandler extends BaseHttpHandler {
    @Override
    public RequestMethod getMethod() {
        return null;
    }

    @Override
    public String getPath() {
        return "/excelmng/getSchema";
    }

    @Override
    public boolean isPublic() {
        return false;
    }

    @Override
    public void handle(HttpServletRequest req, HttpServletResponse res) throws Exception {
        String connectionName = WebUtils.getHTTPRequestParameter(req, "connectionName");
        Connection conn = null;
        JSONArray result = new JSONArray();

        // schema 添加一条为空的缺省选项
        result.add(new JSONObject().put("value", "缺省").put("text","缺省"));

        try{
            conn = JdbcUtils.getConnection(connectionName);
            Dialect dialect = DialectFactory.generateDialect(conn);
            String[] schemaArray = dialect.getSchemas(conn);

            for (int i=0; i<schemaArray.length; i++){
                result.add(JSONObject.create().put("value", schemaArray[i]).put("text", schemaArray[i]));
            }

            WebUtils.printAsJSON(res, new JSONObject().put("status", "success").put("data", result));
        } catch (Exception e){
            e.printStackTrace();
            WebUtils.printAsJSON(res, new JSONObject().put("status", "fail"));
        } finally {
            DBUtils.close(conn);
        }
    }
}
