package com.fr.plugin.decision.http;

import com.fr.decision.fun.impl.BaseHttpHandler;
import com.fr.decision.webservice.v10.user.UserService;
import com.fr.json.JSONArray;
import com.fr.json.JSONObject;
import com.fr.plugin.decision.ExcelMngConfigAccessBridge;
import com.fr.plugin.decision.dao.*;
import com.fr.stable.StringUtils;
import com.fr.stable.db.action.DBAction;
import com.fr.stable.db.dao.DAOContext;
import com.fr.stable.query.QueryFactory;
import com.fr.stable.query.restriction.RestrictionFactory;
import com.fr.third.springframework.web.bind.annotation.RequestMethod;
import com.fr.web.utils.WebUtils;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.ArrayList;
import java.util.List;

public class QueryLinkHttpHandle extends BaseHttpHandler {
    @Override
    public RequestMethod getMethod() {
        return null;
    }

    @Override
    public String getPath() {
        return "/excelmng/querylink";
    }

    @Override
    public boolean isPublic() {
        return false;
    }

    @Override
    public void handle(HttpServletRequest req, HttpServletResponse res) throws Exception {
        boolean containReuse = WebUtils.getHTTPRequestBoolParameter(req,"containReuse");
        final String key = WebUtils.getHTTPRequestParameter(req,"key");
        final String createUser = UserService.getInstance().getCurrentUserIdFromCookie(req);
        JSONArray result = JSONArray.create();

        try {
            List<ExcelMngEntity> entities = ExcelLinkService.getInstance().getAllLink(key, createUser);
            List<ReuseEntity> reuseEntities = ReuseService.getInstance().getLinkByUserName(createUser);

            for (ExcelMngEntity entity : entities) {
                result.add(new JSONObject().put("id",entity.getId()).put("name",entity.getName()).put("create","true"));
            }
            if (containReuse) {
                 for (ReuseEntity entity: reuseEntities) {
                    result.add(new JSONObject().put("id",entity.getId()).put("name",entity.getLinkName()).put("create","false"));
                 }
            }

            WebUtils.printAsJSON(res,new JSONObject().put("data",result));
            return;

        } catch (Exception e) {
            e.printStackTrace();
            WebUtils.printAsJSON(res,new JSONObject().put("status","fail"));
        }
    }
}
