package com.fr.plugin.decision.http;

import com.fr.decision.fun.impl.BaseHttpHandler;
import com.fr.json.JSONObject;
import com.fr.plugin.decision.ExcelMngConfigAccessBridge;
import com.fr.plugin.decision.dao.ExcelMngDao;
import com.fr.plugin.decision.dao.ExcelMngEntity;
import com.fr.stable.db.accessor.DBAccessor;
import com.fr.stable.db.action.DBAction;
import com.fr.stable.db.dao.DAOContext;
import com.fr.stable.query.QueryFactory;
import com.fr.stable.query.restriction.RestrictionFactory;
import com.fr.third.springframework.web.bind.annotation.RequestMethod;
import com.fr.web.utils.WebUtils;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class RenameHttpHandle extends BaseHttpHandler {
    @Override
    public RequestMethod getMethod() {
        return null;
    }

    @Override
    public String getPath() {
        return "/excelmng/rename";
    }

    @Override
    public boolean isPublic() {
        return false;
    }

    @Override
    public void handle(HttpServletRequest req, HttpServletResponse res) throws Exception {
        final String name = WebUtils.getHTTPRequestParameter(req, "name");
        final String id = WebUtils.getHTTPRequestParameter(req,"id");
        try {

            final ExcelMngEntity entity = ExcelMngConfigAccessBridge.getDbAccessor().runQueryAction(new DBAction<ExcelMngEntity>() {
                @Override
                public ExcelMngEntity run(DAOContext daoContext) throws Exception {
                    return daoContext.getDAO(ExcelMngDao.class).findOne(QueryFactory.create().addRestriction(RestrictionFactory.eq("id",id)));
                }
            });

            entity.setName(name);

            ExcelMngConfigAccessBridge.getDbAccessor().runDMLAction(new DBAction<ExcelMngEntity>() {
                @Override
                public ExcelMngEntity run(DAOContext daoContext) throws Exception {
                    daoContext.getDAO(ExcelMngDao.class).update(entity);
                    return null;
                }
            });

            WebUtils.printAsJSON(res,new JSONObject().put("status","success"));
            return;
        } catch (Exception e) {
            e.printStackTrace();
            WebUtils.printAsJSON(res,new JSONObject().put("status","fail"));
        }
    }
}
