package com.fr.plugin.decision.request.handler;

import com.fr.json.JSONArray;
import com.fr.json.JSONObject;
import com.fr.plugin.decision.HWUtils;
import com.fr.stable.StringUtils;
import com.fr.third.org.apache.poi.hssf.usermodel.HSSFSheet;
import com.fr.third.org.apache.poi.hssf.usermodel.HSSFWorkbook;
import com.fr.third.v2.org.apache.poi.xssf.usermodel.XSSFSheet;
import com.fr.third.v2.org.apache.poi.xssf.usermodel.XSSFWorkbook;
import com.fr.web.utils.WebUtils;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * created by ezreal 2020/1/12
 */
public class ExcelFiledHandler extends HWAbstractHandler {
    public static final String PATH = "/hw/excel/filed";
    private final int MAX_ROW = 1000000;

    @Override
    public String getPath() {
        return PATH;
    }


    @Override
    protected void deal(HttpServletRequest req, HttpServletResponse res, JSONObject para, JSONObject result) {
        String attachId = para.getString("attachId");
        String fileName = para.getString("fileName", StringUtils.EMPTY);

        if (fileName.endsWith(".xlsx")) {
            XSSFWorkbook sheets = HWUtils.getExcelWork(attachId);
            if (sheets != null) {
                int sheetNo = para.getInt("sheetNo");
                XSSFSheet xssfSheet = sheets.getSheetAt(sheetNo);
                int count = xssfSheet.getLastRowNum();//总行数
                if (count >= MAX_ROW) {//大于最大行数就提示
                    result.put("msg", "数据大于" + MAX_ROW + "行");
                    return;
                }
                JSONArray data = HWUtils.getSheetFiled(xssfSheet);
                result.put(SUCCESS, true).put("data", data);
            }
        } else if (fileName.endsWith(".xls")) {
            HSSFWorkbook excel2003Work = HWUtils.getExcel2003Work(attachId);
            if (excel2003Work != null) {
                int sheetNo = para.getInt("sheetNo");
                HSSFSheet sheet = excel2003Work.getSheetAt(sheetNo);
                int count = sheet.getLastRowNum();//总行数
                if (count >= MAX_ROW) {//大于最大行数就提示
                    result.put("msg", "数据大于" + MAX_ROW + "行");
                    return;
                }
                JSONArray data = HWUtils.get2003SheetFiled(sheet);
                result.put(SUCCESS, true).put("data", data);
            }
        }
    }
}
