package com.fr.plugin.decision.request.handler;

import com.fr.cache.Attachment;
import com.fr.cache.AttachmentSource;
import com.fr.json.JSONArray;
import com.fr.json.JSONObject;
import com.fr.plugin.decision.HWUtils;
import com.fr.stable.StringUtils;
import com.fr.third.org.apache.poi.hssf.usermodel.HSSFWorkbook;
import com.fr.third.v2.org.apache.poi.xssf.usermodel.XSSFWorkbook;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.InputStream;

/**
 * created by ezreal 2020/1/12
 */
public class ExcelSheetCountHandler extends HWAbstractHandler {
    public static final String PATH = "/hw/excel/sheet";

    @Override
    public String getPath() {
        return PATH;
    }


    @Override
    protected void deal(HttpServletRequest req, HttpServletResponse res, JSONObject para, JSONObject result) {
        try {
            String attachId = para.getString("attachId");
            String fileName = para.getString("fileName", StringUtils.EMPTY);
            int count = 1;
            JSONArray data = JSONArray.create();
            if (fileName.endsWith(".xlsx")) {
                XSSFWorkbook sheets = HWUtils.getExcelWork(attachId);

                if (sheets != null) {
                    count = sheets.getNumberOfSheets();
                    for (int i = 0; i < count; i++) {
                        JSONObject object = JSONObject.create();
                        object.put("value", i).put("text", sheets.getSheetName(i));
                        data.add(object);
                    }
                    result.put(SUCCESS, true).put("data", data);
                }
            } else if (fileName.endsWith(".xls")) {
                HSSFWorkbook excel2003Work = HWUtils.getExcel2003Work(attachId);
                if (excel2003Work != null) {
                    count = excel2003Work.getNumberOfSheets();
                    for (int i = 0; i < count; i++) {
                        JSONObject object = JSONObject.create();
                        object.put("value", i).put("text", excel2003Work.getSheetName(i));
                        data.add(object);
                    }
                    result.put(SUCCESS, true).put("data", data);
                }
            }


        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
