package com.fr.plugin.decision.request.handler;

import com.fr.decision.fun.impl.BaseHttpHandler;
import com.fr.json.JSONObject;
import com.fr.third.springframework.web.bind.annotation.RequestMethod;
import com.fr.web.utils.WebUtils;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.nio.charset.StandardCharsets;

/**
 * created by ezreal 2020/1/12
 */
public abstract class HWAbstractHandler extends BaseHttpHandler {
    public static String SUCCESS="success";

    @Override
    public RequestMethod getMethod() {
        return null;
    }

    @Override
    public boolean isPublic() {
        return false;
    }

    @Override
    public void handle(HttpServletRequest req, HttpServletResponse res) throws Exception {
        JSONObject para=getParaJSON(req);
        JSONObject result=JSONObject.create().put(SUCCESS,false);
        deal(req,res,para,result);
        WebUtils.printAsJSON(res,result);
    }
    protected abstract void deal(HttpServletRequest req, HttpServletResponse res, JSONObject para, JSONObject result) throws Exception;

    /**
     * 获取json参数方法
     *
     * @param req 请求
     * @return
     * @throws IOException
     * @throws UnsupportedEncodingException
     */
    public JSONObject getParaJSON(HttpServletRequest req) throws IOException, UnsupportedEncodingException {
        JSONObject result = JSONObject.create();
        try {
            BufferedReader br = new BufferedReader(new InputStreamReader(req.getInputStream(), StandardCharsets.UTF_8));
            String line = null;
            StringBuilder sb = new StringBuilder();
            while ((line = br.readLine()) != null) {
                sb.append(line);
            }
            return new JSONObject(sb.toString());
        } catch (Exception e) {
            e.printStackTrace();
        }
        return result;
    }
}
