!(function () {
    var Model = BI.inherit(Fix.Model, {
        _init: function () {
            this.add = this.options.add;
        },

        state: function () {
            return {
                perCount: 10,
                page: 1
            };
        },

        context: ["items", "connection", "schema", "aliasName", "tableName", "excelItems", "infoId"],

        computed: {
            perItems: function () {
                var self = this;
                var start = (self.model.page - 1) * self.model.perCount;
                var end = self.model.page * self.model.perCount;
                var self = this;
                return BI.filter(self.model.items, function (index, item) {
                    return index + 1 > start && index + 1 <= end;
                })
            },
            count: function () {
                return this.model.items.length;
            },
            pages: function () {
                return Math.ceil(this.model.count / this.model.perCount);
            }
        },

        actions: {
            initData: function (callback) {
                callback();
            },
            setPage: function (v) {
                this.model.page = v;
            },
            addItems: function () {
                this.model.items = BI.concat(this.model.items, {
                    id: BI.UUID(),
                    colName: "",
                    colType: "12",
                    colLength: "255",
                    excelCol: "",
                    primaryKey: false
                })
            },
            removeItems: function (id) {
                BI.remove(this.model.items, function (index, item) {
                    return item.id == id
                });
            },
            updateItemColName:function (id, colName) {
                BI.each(this.model.items,function (index, item) {
                    if(item.id==id){
                        item.colName=colName;
                    }
                });
            },
            updateItemColType:function (id, colType) {
                BI.each(this.model.items,function (index, item) {
                    if(item.id==id){
                        item.colType=colType;
                    }
                });
            },
            updateItemColLength:function (id, colLength) {
                BI.each(this.model.items,function (index, item) {
                    if(item.id==id){
                        item.colLength=colLength;
                    }
                });
            },
            updateItemExcelCol:function (id, excelCol) {
                BI.each(this.model.items,function (index, item) {
                    if(item.id==id){
                        item.excelCol=excelCol;
                    }
                });
            },
            updateItemPrimaryKey:function (id, primaryKey) {
                BI.each(this.model.items,function (index, item) {
                    if(item.id==id){
                        item.primaryKey=primaryKey;
                    } /*else {
                        item.primaryKey=false;
                    }*/
                });
            }
        }
    });
    BI.model("dec.hw.table.col.attr.model", Model);
})();
