;!(function () {
    var EDITOR_WIDTH = 480, EDITOR_HEIGHT = 22, LABEL_WIDTH = 100;
    var info = BI.inherit(BI.Widget, {
        props: {
            typeItems: [],
            levelItems: [],
            departId: "",
            departName: "",
            departType: "",
            institution: "",
            departLevel: "",
            startDate: {},
            endDate: {},
            add: true,
            info: {}
        },
        _store: function () {
            return BI.Models.getModel("dec.hw.table.attr.model");
        },
        watch: {
            schemaItems:function () {
                this.schema.setValue();
            },
            isSchemaLoaded: function (v) {
                this.schema.setEnable(v);
            }
        },
        beforeInit: function (callback) {
            this.store.initData(callback);
        },
        render: function () {
            var self = this, o = this.options, borderEditorWidth = EDITOR_WIDTH - 2;
            return {
                type: "bi.vertical",
                width: 640,
                vgap: 15,
                items: [{
                    type: "bi.vertical_adapt",
                    items: [{
                        type: "bi.label",
                        textAlign: "right",
                        cls: "dec-font-weight-bold",
                        text: "数据源:",
                        title: "数据源",
                        width: LABEL_WIDTH
                    }, {
                        el: {
                            type: "bi.text_value_combo",
                            lgap: 4,
                            disabled: !o.add,
                            cls: "bi-border",
                            textAlign: "left",
                            value: o.info.connection,
                            items: self.model.connectionItems,
                            //   items: self.model.typeItems,
                            width: borderEditorWidth,
                            height: EDITOR_HEIGHT,
                            ref: function (_ref) {
                                self.connection = _ref;
                            },
                            listeners: [
                                {
                                    eventName: "EVENT_CHANGE",
                                    action: function () {
                                        self.store.setConnection(this.getValue()[0]);
                                        self.store.getSchemaItems(this.getValue()[0]);
                                    }
                                }
                            ]
                        },
                        lgap: 10
                    }]
                }, {
                    type: "bi.vertical_adapt",
                    items: [{
                        type: "bi.label",
                        textAlign: "right",
                        cls: "dec-font-weight-bold",
                        text: "别名(*):",
                        title: "别名",
                        width: LABEL_WIDTH
                    }, {
                        el: {
                            type: "bi.text_editor",
                            lgap: 4,
                            cls: "bi-border",
                            textAlign: "left",
                            value: o.info.aliasName,
                            width: borderEditorWidth,
                            disabled: !o.add,
                            height: EDITOR_HEIGHT,
                            ref: function (_ref) {
                                self.alias = _ref;
                            },
                            listeners: [
                                {
                                    eventName: "EVENT_CHANGE",
                                    action: function () {
                                        self.store.setAliasName(this.getValue());
                                    }
                                }
                            ]
                        }, lgap: 10
                    }]
                }, {
                    type: "bi.vertical_adapt",
                    items: [{
                        type: "bi.label",
                        textAlign: "right",
                        cls: "dec-font-weight-bold",
                        text: "表名(*):",
                        title: "表名",
                        width: LABEL_WIDTH
                    }, {
                        el: {
                            type: "bi.text_editor",
                            lgap: 4,
                            cls: "bi-border",
                            textAlign: "left",
                            width: borderEditorWidth,
                            disabled: !o.add,
                            value: o.info.tableName,
                            height: EDITOR_HEIGHT,
                            ref: function (_ref) {
                                self.tableName = _ref;
                            },
                            listeners: [
                                {
                                    eventName: "EVENT_CHANGE",
                                    action: function () {
                                        self.store.setTableName(this.getValue());
                                    }
                                }
                            ]
                        }, lgap: 10
                    }]
                }]
            }
        },
        getValue: function () {
            var self = this;
            return {
                id: self.subjectId.getValue(),
                subjectName: self.subjectName.getValue(),
                subjectType: self.subjectType.getValue()[0],
                accountSubject: self.accountSubject.getValue()[0],
                beginDate: Dec.AMB.getDynamicDateValue(self.beginDate.getValue()),
                endDate: Dec.AMB.getDynamicDateValue(self.endDate.getValue()),
                mark: self.mark.getValue()
            }
        },
        setValue: function (v) {
            var self = this;
            self.subjectId.setValue(v.id);
            self.subjectName.setValue(v.subjectName);
            self.subjectType.setValue([v.subjectType]);
            self.accountSubject.setValue([v.accountSubject]);
            self.beginDate.setValue(Dec.AMB.createDateWidgetValue(v.beginDate));
            self.endDate.setValue(Dec.AMB.createDateWidgetValue(v.endDate));
            self.mark.setValue(v.mark);
        },
        getSchemaValue: function () {
            return this.schema.getValue()
        },
        _itemsCreator:function (options, populate) {
            var self = this, o = this.options, keyword = options.keywords && options.keywords[0];
            var filter = BI.filter(self.model.schemaItems,function (i, value) {
                if(BI.isEmpty(keyword)){
                    return true;
                }
                return BI.contains(value.value, keyword);
            });
            populate({
                items: self._processSchemaItems(filter)
            })
        },
        _processSchemaItems:function (items) {
            var self = this;
            return BI.map(items, function (i, v) {
                var res = {
                    type: "bi.icon_text_item",
                    value: v.value,
                    cls: "item-check-font bi-list-item"
                };
                return res;
            });
        }

    });
    BI.shortcut("dec.hw.table.attr", info);
})();