!(function () {
    var AuthPane = BI.inherit(BI.Widget, {
        props: {
            baseCls: ""
        },

        _store: function () {
            return BI.Models.getModel("dec.model.mng.authPane");
        },
        
        render: function () {
            var self = this, o = this.options;
            var left = {
                type: "dec.common.resizeable_layout",
                ref: function (_ref) {
                    self.left = _ref;
                },
                width: 240,
                maxSize: 450,
                minSize: 200,
                resize: BI.bind(self.resize, this),
                item: {
                    type: "dec.excelexport.left",
                    showButton: false,
                    cls: "bi-border-right"
                }
            };

            var right = {
                type: "dec.auth.right",
                ref: function (_ref) {
                    self.right = _ref;
                }
            };

            return {
                type: "bi.vtape",
                items: [{
                        type: "bi.absolute",
                        items: [
                            {
                                el: {
                                    type: "bi.htape",
                                    cls: "bi-card",
                                    ref: function (_ref) {
                                        self.wrapper = _ref;
                                    },
                                    items: [
                                        {
                                            el: left,
                                            width: 240
                                        }, {
                                            el: right
                                        }
                                    ]
                                },
                                top: 10, right: 10, left: 10, bottom: 10
                            }
                        ]
                    }
                ]
            };
        },

        resize: function (size) {
            var self = this;
            self.wrapper.options.items[0].width = size;
            self.wrapper.resize();
        }
    });
    BI.shortcut("dec.mng.authPane", AuthPane);
})();