!(function () {
    var Right = BI.inherit(BI.Widget, {

        props: {
            baseCls: ""
        },

        _store: function () {
            return BI.Models.getModel("dec.model.auth.right");
        },

        watch:{
            selectedLink:function(v){
                var self = this;
                self.loader.setVisible(true);
                self.store.setAllUser([]);
                self.store.setPage(2);
                self.store.initAuthData(function(){
                    self.store.initData(function(e){
                        self.loader.populate(e);
                        self.store.setPage(2);
                    }, 1);
                });
            },
            keyword:function(v){
                var self = this;
                self.store.initData(function(e){
                    self.loader.populate(e);
                    self.store.setPage(2);
                }, 1);
            }
        },
        render: function () {
            var self = this, o = this.options;

            return {
                type: "bi.vtape",
                items: [{
                    el:{
                        type: "bi.left_right_vertical_adapt",
                        cls: "bi-border-bottom",
                        items:{
                            left:[{
                                type: "bi.label",
                                text: "人员列表",
                                textAlign: "left",
                                hgap: 5,
                                lgap: 20
                            },{
                                type: "bi.search_editor",
                                width: 200,
                                watermark: "用户搜索",
                                listeners: [{
                                    eventName: "EVENT_CHANGE",
                                    action: function() {
                                        self.store.setKeyword(this.getKeywords()[0]);
                                    }
                                },{
                                    eventName: "EVENT_CLEAR",
                                    action: function() {
                                        self.store.setAllUser([]);
                                        self.store.setKeyword(BI.emptyStr);
                                    }
                                }]
                            }],
                            right:[{
                                type: "bi.label",
                                text: "权限",
                                textAlign: "left",
                                hgap: 5,
                                rgap: 20
                            }]
                        }
                    },
                    height: 40,
                },{
                    el:{
                        type: "bi.loader",
                        height: "90%",
                        invisible: true,
                        ref: function(_ref) {
                            self.loader = _ref
                        },
                        // options 表示加载的次数 times:1
                        itemsCreator: function (options, populate) {
                            self.store.initData(populate, self.model.page);
                            self.store.setPage(self.model.page+1) ;
                        },
                        hasNext: function (options) {
                            return self.model.hasNext;
                        }
                    },
                    tgap: 15
                }]
            };
        }
    });
    BI.shortcut("dec.auth.right", Right);
})();