!(function(){
    var Store = BI.inherit(Fix.Model, {
        state: function () {
            return {
                keyword: "",
                allUser:[],
                authUser:[],
                page: 1,
                count: 100,
                userName: "",
                hasNext: true
            };
        },
        context:["selectedLink"],
        computed: {
        },
        actions: {
            initData:function(callback, page){
                var self = this;
                Dec.HW.getAllUserData({
                    page:page,
                    count:self.model.count,
                    keyword:self.model.keyword
                },function(e){
                    if (e.status) {
                        self.model.hasNext = e.data.hasNext;
                        self.model.allUser = e.data.items;
                        callback && callback(self._formatItems(e.data.items))
                    }
                });
            },

            initAuthData:function(callback){
                var self = this;
                Dec.HW.getAuthUserData({
                    linkName: self.model.selectedLink                          
                },function(res){
                    if (res.status) {
                        self.model.authUser = res.data;
                        callback && callback()
                    }
                })
            },

            setAllUser: function (v) {
                this.model.allUser = v
            },

            setKeyword: function (v) {
                this.model.keyword = v
            },

            setPage: function (v) {
                this.model.page = v
            },

            updateAuth: function(v){
                var self = this;
                Dec.HW.updateLinkAuth({
                    linkName: self.model.selectedLink,
                    userName: self.model.userName,
                    auth: v                       
                },function(res){
                    self.initAuthData(BI.emptyFn);
                })
            },

            _formatItems:function(v){
                var self = this;
                return BI.map( v, function(i,val){
                    var selected = BI.contains(self.model.authUser, val.id);
                    var item = {
                        type:"bi.htape",
                        cls: "bi-list-item-active",
                        ref: function(_ref) {
                            self.tape = _ref
                        },
                        height:24,
                        items:[{
                            el:{
                                type:"bi.label",
                            },
                            width:60
                        },{
                            el:{
                                type:"bi.label",
                                value: val.realName + " (" + val.username + ")",
                                text: val.realName + " (" + val.username + ")"
                            },
                        },{
                            el:{
                                type:"dec.auth.checkbox",
                                selected:selected,
                                value: val.id,
                                hoverHandler:{
                                    moveIn:function(arguments){
                                        self.model.userName = arguments
                                    },
                                    moveOut:function(){
                                    }
                                },
                                listeners: [{
                                    eventName: BI.Controller.EVENT_CHANGE,
                                    action: function() {
                                        self.updateAuth(this.isSelected());
                                    }
                                }]
                            },
                            rgap:10
                        },{
                            el:{
                                type:"bi.label",
                            },
                            width:40
                        }]
                    }
                    return item;
                })
            }
        }
    });
    BI.model("dec.model.auth.right", Store);
})();