!(function () {
    var i = BI.inherit(BI.Widget, {
        props: {
            baseCls: "dec-page-table",
            perPage: 10,
            showPager: !0,
            columnSize: []
        },
        _store: function() {
            return BI.Models.getModel("dec.model.page.table")
        },
        watch: {
            sort: function(e) {
                this.fireEvent(i.EVENT_SORT, e)
            },
            "totalCount || currentPage": function() {
                this.pager.setCount(this.model.totalCount),
                this.pager.setPage(this.model.currentPage),
                this.pager.setAllPages(Math.ceil(this.model.totalCount / this.options.perPage))
            }
        },
        render: function() {
            var t = this
                , e = this.options;
            return {
                type: "bi.vertical",
                scrollx: true,
                items: [{
                    type: "dec.page.table.header",
                    columnSize: e.columnSize,
                    items: e.header
                }, {
                    type: "bi.button_group",
                    cls: "table-items",
                    layouts: [{
                        type: "bi.vertical",
                        scrollx: true
                    }],
                    items: this._createItems(e.items),
                    ref: function(e) {
                        t.listGroup = e
                    },
                    height: e.listHeight
                }, {
                    type: "dec.pager",
                    height: 30,
                    invisible: !e.showPager,
                    tgap: 10,
                    count: e.totalCount,
                    pages: 0 === e.totalCount ? 1 : Math.ceil(e.totalCount / e.perPage),
                    curr: e.currentPage,
                    ref: function(e) {
                        t.pager = e
                    },
                    listeners: [{
                        eventName: i.PAGER_EVENT_CHANGE,
                        action: function() {
                            t.fireEvent(i.PAGER_EVENT_CHANGE, this.getCurrentPage())
                        }
                    }]
                }]
            }
        },
        setCount: function(e) {
            this.store.setCount(e)
        },
        setPage: function(e) {
            this.store.setPage(e)
        },
        populate: function(e) {
            this.listGroup.populate(this._createItems(e))
        },
        _createItems: function(e) {
            var i = this.options;
            return BI.map(e, function(e, t) {
                return {
                    type: "dec.page.table.row",
                    odd: BI.isOdd(e),
                    columnSize: i.columnSize,
                    item: t
                }
            })
        }
    });
    i.PAGER_EVENT_CHANGE = "EVENT_CHANGE",
    i.EVENT_SORT = "EVENT_SORT",
    BI.shortcut("dec.page.table.plugin", i)
})();