!(function () {
    var Left = BI.inherit(BI.Widget, {

        props: {
            baseCls: "",
            showButton: false,
            containReuse: false
        },

        _store: function () {
            return BI.Models.getModel("dec.model.excelexport.left");
        },

        render: function () {
            var self = this, o = this.options;
            return {
                type: "bi.vtape",
                items: [
                    {
                        type: "bi.left_right_vertical_adapt",
                        cls: "bi-border-bottom",
                        items:{
                            left: [{
                                type: "bi.label",
                                text: "数据列表",
                                textAlign: "left",
                                hgap: 5,
                                height: 40
                            }],
                            right: [{
                                type: "bi.icon_button",
                                cls: "plus-font",
                                invisible: !o.showButton,
                                width: 16,
                                hgap: 10,
                                handler: function () {
                                    var pane = {
                                        type: "dec.hw.table.add.popup",
                                        add:true,
                                        infoId:"add",
                                        onClickConfirm: function (table, callback) {
                                            var tableData = BI.deepClone(table);
                                            BI.hwfield2ColTypeDeal(tableData.items);
                                            Dec.HW.importTableData(tableData, function (res) {
                                                if (res.status === "success") {
                                                    BI.Utils.addTables2Pack({
                                                        packId: "__my_analysis__" + BI.Utils.getCurrentUserId(),
                                                        tables: [{
                                                            tableName: tableData.tableName,
                                                            connectionName: tableData.connection
                                                        }]
                                                    }, function () {
                                                        callback(res);
                                                        self.linkListPane.populate();
                                                    });
                                                } else {
                                                    callback(res);
                                                    self.linkListPane.populate();
                                                }
                                            });
                                        },
                                        listeners: [
                                            {
                                                eventName: "EVENT_CLOSE",
                                                action: function () {
                                                    BI.Popovers.remove(self.getName() + "add");
                                                }
                                            }
                                        ]
                                    };
                                    BI.Popovers.create(self.getName() + "add", {
                                        type: "bi.popover",
                                        header: "添加Excel导入链接",
                                        body: pane,
                                        width: 700,
                                        height: 700,
                                        listeners: [
                                            {
                                                eventName: "EVENT_CLOSE",
                                                action: function () {
                                                    BI.Popovers.remove(self.getName() + "add");
                                                }
                                            }
                                        ]
                                    }).open(self.getName() + "add");
                                }
                            }]
                        },
                        height: 40
                    }, {
                        type: "dec.excelexport.left.linklist",
                        containReuse: o.containReuse,
                        ref: function (_ref) {
                            self.linkListPane = _ref;
                        }
                    }
                ]
            };
        },

        resize: function (size) {
            var self = this;
            self.wrapper.options.items[0].width = size;
            self.wrapper.resize();
        }
    });
    BI.shortcut("dec.excelexport.left", Left);
})();