!(function () {
    var ICON_WIDTH = 26;
    var Item = BI.inherit(BI.BasicButton, {

        props: {
            baseCls: "dec-tabledata-set-list-item",
            $testId: "dec-tabledata-set-list-item",
            height: 24,
            value: "",
            text: "",
            create: false
        },

        _store: function () {
            return BI.Models.getModel("dec.model.excelexport.left.linklist.item", this.options);
        },

        render: function () {
            var self = this, o = this.options;
            this.storeValue = o.value;
            return {
                type: "bi.htape",
                css: o.create == "true" ? {"color":"blue"}:{},
                items: [{
                    type: "bi.center_adapt",
                    width: 24,
                    cls: "dcm-link-font",
                    hgap: 5,
                    items: [{
                        type: "bi.icon"
                    }]
                }, {
                    type: "bi.shelter_editor",
                    allowBlank: false,
                    value: o.value,
                    text: o.text,
                    validationChecker: BI.bind(this.store.nameChecker, this.store),
                    errorText: function (v) {
                        return BI.i18nText(BI.isEmptyString(v) ? "Dec-Data_Set_Server_Name_Empty" : "Dec-Data_Set_Server_Name_Duplicate");
                    },
                    title: function () {
                        return self.editor.getValue();
                    },
                    ref: function (_ref) {
                        self.editor = _ref;
                    },
                    listeners: [{
                        eventName: BI.ShelterEditor.EVENT_CONFIRM,
                        action: function () {
                            self.storeValue = this.getValue();
                            self.fireEvent("EVENT_RENAME", self.storeValue);
                        }
                    }]
                }, {
                    type: "bi.vertical_adapt",
                    width: ICON_WIDTH * 2 ,
                    cls: "operations",
                    invisible: o.create != "true",
                    items: [{
                        type: "bi.icon_button",
                        cls: "rename-font",
                        height: o.height,
                        width: ICON_WIDTH,
                        stopPropagation: true,
                        title: BI.i18nText("Dec-Basic_Rename"),
                        handler: function () {
                            self.editor.focus();
                        }
                    }, {
                        type: "dec.bubble.combo",
                        el: {
                            type: "bi.icon_button",
                            cls: "default-delete-font",
                            height: o.height,
                            width: ICON_WIDTH,
                            title: BI.i18nText("Dec-Basic_Delete")
                        },
                        text: BI.i18nText("Dec-Data_Set_Confirm_Delete"),
                        onClickConfirm: function () {
                            self.fireEvent("EVENT_DELETE");
                            self.deleteCombo.hideView();
                        },
                        ref: function (_ref) {
                            self.deleteCombo = _ref;
                        }
                    }]
                }]
            };
        },

        getValue: function () {
            return this.storeValue;
        },

        setValue: function (v) {
            this.editor.setValue(v);
        }
    });
    BI.shortcut("dec.excelexport.left.linklist.item", Item);
})();