!(function () {
    var SINGLE = BI.inherit(BI.Widget, {

        props: {
            baseCls: "dec-directory-left-single",
            $testId: "dec-directory-left-single",
            containReuse: false
        },

        _store: function () {
            return BI.Models.getModel("dec.model.excelexport.left.linklist", this.options);
        },

        beforeInit: function (callback) {
            this.store.initData(callback);
        },

        watch:{
            linklist: function () {
                this.linkListPane.populate(this.model.items);
                this.linkListPane.setValue(this.model.selectedName);
            }
        },

        render: function () {
            var self = this, o = this.options;
            return {
                type: "bi.absolute",
                items: [{
                    el: {
                        type: "bi.button_group",
                        chooseType: BI.ButtonGroup.CHOOSE_TYPE_SINGLE,
                        layouts: [{
                            type: "bi.vertical"
                        }],
                        items: self.model.items,
                        value: self.model.selectedLink,
                        listeners: [{
                            eventName: BI.ButtonGroup.EVENT_CHANGE,
                            action: function (v) {
                                self.store.setSelectedLink(v);
                            }
                        }],
                        ref: function (_ref) {
                            self.linkListPane = _ref;
                        }
                    }, top: 10, left: 0, right: 0, bottom: 10
                }]
            };
        },

        populate: function () {
            var self = this;
            self.store.initData(
                self.linkListPane.populate(this.model.items)
            );
        }
    });
    BI.shortcut("dec.excelexport.left.linklist", SINGLE);
})();