!(function () {
    var Model = BI.inherit(Fix.Model, {

        state: function () {
            return {
                linklist: []
            };
        },

        context: ["selectedLink"],

        computed: {
            items: function () {
                var self = this , o = this.options;

                return BI.map(self.model.linklist, function (i, v) {
                    return {
                        type: "dec.excelexport.left.linklist.item",
                        value: v.name,
                        create: v.create,
                        listeners: [{
                            eventName: "EVENT_RENAME",
                            action: function (name) {
                                self.rename(v, name);
                            }
                        }, {
                            eventName: "EVENT_DELETE",
                            action: function () {
                                self.deleteLink(v.id);
                            }
                        }]
                    };
                });
            }
        },

        actions: {
            initData: function(callback){
                var self = this ;
                Dec.reqGet("/url/excelmng/querylink?containReuse=" + self.options.containReuse,null,function(e){
                    self.model.linklist = e.data;
                    BI.isFunction(callback) && callback();
                },BI.emptyFn)
            },

            //link重命名
            rename: function(item, name){
                if (item.name === name) {
                    return;
                }
                var self = this;
                var linkSet = BI.extend({}, item, {
                    id: item.id,
                    name: item.name
                });

                Dec.reqGet("/url/excelmng/rename?id="+item.id+"&name="+name,
                    null,
                    function (e) {
                        if (e.status === "success"){
                            BI.remove(self.model.linklist, function (i, v) {
                                return v.id === item.id;
                            });
                            self.model.linklist.unshift(BI.extend(linkSet, {
                                name: name
                            }));
                            if (self.model.selectedLink === linkSet.name) {
                                self.setSelectedDataSet(name);
                            }
                        }
                    },
                    BI.emptyFn)
            },

            //link删除
            deleteLink: function(id){
                var self = this;
                Dec.reqGet("/url/excelmng/delete?id="+id,
                    null,
                    function (e) {
                        if (e.status === "success"){
                            BI.remove(self.model.linklist, function (i, v) {
                                return v.id === id;
                            });
                        } else {
                            BI.Msg.toast(BI.i18nText("Dec-Basic_Delete_Fail"), {level: "error"});
                        }
                    },
                    BI.emptyFn)
            },

            setSelectedLink: function(v){
                this.model.selectedLink = v;
            }
        }
    });
    BI.model("dec.model.excelexport.left.linklist", Model);
}());