!(function () {
    var Left = BI.inherit(BI.Widget, {

        props: {
            baseCls: ""
        },

        _store: function () {
            return BI.Models.getModel("dec.model.excelexport.right");
        },

        render: function () {
            var self = this, o = this.options;

            return {
                type: "bi.vtape",
                items: [
                    {
                        type: "bi.left_right_vertical_adapt",
                        cls: "bi-border-bottom",
                        items:{
                            left: [{
                                type: "bi.label",
                                text: "数据明细",
                                textAlign: "left",
                                hgap: 5,
                                height: 40
                            }],
                            right: [{
                                type: "bi.button",
                                text: "刷新",
                                level: "success",
                                minWidth:60,
                                hgap:10,
                                handler:function(){
                                    if (BI.isKey(self.model.selectedLink)) {
                                        self.table.populate();
                                    }
                                }
                            },{
                                type: "bi.button",
                                text: "覆盖",
                                level: "common",
                                minWidth:60,
                                hgap:10,
                                handler:function () {
                                    var pane = {
                                        type: "dec.hw.table.add.popup",
                                        add:false,
                                        infoId:"cover",
                                        aliasName: self.model.selectedLink,
                                        onClickConfirm: function (table, callback) {
                                            var tableData = BI.deepClone(table);
                                            BI.hwfield2ColTypeDeal(tableData.items);
                                            Dec.HW.importTableData(tableData, callback);
                                        },
                                        listeners: [
                                            {
                                                eventName: "EVENT_CLOSE",
                                                action: function () {
                                                    BI.Popovers.remove(self.getName() + "edit");
                                                }
                                            }
                                        ]
                                    };
                                    if (self.model.selectedLink === BI.emptyStr) {
                                        BI.Msg.toast("先选择左侧链接");
                                        return;
                                    }
                                    BI.Popovers.create(self.getName() + "edit", {
                                        type: "bi.popover",
                                        header: "覆盖",
                                        body: pane,
                                        width: 700,
                                        height: 700,
                                        listeners: [
                                            {
                                                eventName: "EVENT_CLOSE",
                                                action: function () {
                                                    BI.Popovers.remove(self.getName() + "edit");
                                                }
                                            }
                                        ]
                                    }).open(self.getName() + "edit");
                                }
                            },{
                                type: "bi.button",
                                text: "追加",
                                level: "common",
                                minWidth:60,
                                hgap:10,
                                handler:function () {
                                    var pane = {
                                        type: "dec.hw.table.add.popup",
                                        add:false,
                                        infoId:"addTo",
                                        aliasName: self.model.selectedLink,
                                        onClickConfirm: function (table, callback) {
                                            var tableData = BI.deepClone(table);
                                            BI.hwfield2ColTypeDeal(tableData.items);
                                            Dec.HW.importTableData(tableData, callback)
                                        },
                                        listeners: [
                                            {
                                                eventName: "EVENT_CLOSE",
                                                action: function () {
                                                    BI.Popovers.remove(self.getName() + "edit");
                                                }
                                            }
                                        ]
                                    };
                                    if (self.model.selectedLink === BI.emptyStr) {
                                        BI.Msg.toast("先选择左侧链接");
                                        return;
                                    }
                                    BI.Popovers.create(self.getName() + "edit", {
                                        type: "bi.popover",
                                        header: "追加",
                                        body: pane,
                                        width: 700,
                                        height: 700,
                                        listeners: [
                                            {
                                                eventName: "EVENT_CLOSE",
                                                action: function () {
                                                    BI.Popovers.remove(self.getName() + "edit");
                                                }
                                            }
                                        ]
                                    }).open(self.getName() + "edit");
                                }
                            }]
                        },
                        height: 40
                    }, {
                        type: "dec.excelexport.right.table",
                        ref:function(_ref){
                            self.table = _ref
                        }
                    }
                ]
            };
        }

    });
    BI.shortcut("dec.excelexport.right", Left);
})();