!(function () {
    var Counter = BI.inherit(BI.Widget, {

        _store: function () {
            return BI.Models.getModel("dec.model.excelexport.right.table");
        },

        watch:{
            "header||items": function (v) {
                var self = this;
                self.pager.setAllPages(0 === self.model.totalCount ? 1 : Math.ceil(self.model.totalCount / self.model.perCount));
                self.table.populate(self.model.items, [self.model.header]);
            },
            selectedLink:function (v){
                this.pager.setPage(1);
                this.tabpane.setVisible(true);
            }
        },

        render: function () {
            var self = this, o = this.options;
            return {
                type:"bi.absolute",
                items:[{
                    el:{
                        type:"bi.absolute",
                        invisible: true,
                        items:[{
                            el:{
                                type: "bi.preview_table",
                                header: [self.model.header],
                                items: self.model.items,
                                headerRowSize: 40,
                                ref: function (_ref) {
                                    self.table = _ref;
                                }
                            },
                            top:0,bottom:0,left:0,right:0
                        }],
                        ref: function (_ref) {
                            self.tabpane = _ref;
                        }
                    },
                    top:10,bottom:30,left:10,right:10
                },{
                    el:{
                        type: "dec.pager",
                        height: 30,
                        tgap: 10,
                        count: self.model.totalCount,
                        pages: 0 === self.model.totalCount ? 1 : Math.ceil(self.model.totalCount / self.model.perCount),
                        ref: function(_ref) {
                            self.pager = _ref
                        },
                        listeners: [{
                            eventName: "EVENT_CHANGE",
                            action: function() {
                                self.store.setPage(this.getCurrentPage());
                            }
                        }]
                    },
                    bottom:0,right:30
                }]
            };
        },

        populate: function(){
            this.model.currentPage = 1;
            this.pager.setPage(1);
            this.store.initData();
        }
    });
    BI.shortcut("dec.excelexport.right.table", Counter);
})();